	$(function() {
			var chating = false; //если чат активен, то true!
			var mynick = "";
			var roomID = Number(window.location.pathname.match(/\/room\/(\d+)$/)[1]);
			var socket = io();
			var max_nick_length = 16;
			var max_users_count = 20;

			function cmd(acmd, params) {
				if (!params) {
					params = {}
				}
				console.log('cmd: ' + acmd, params);
				socket.emit(acmd, params);
			}

			/* опись входящих событий */

			socket.on('connect', function() {
				socket.emit('initme', {"roomID": roomID});
			});

			socket.on('disconnect', function() {
				$("#loginForm").fadeIn(200);
				$("#chatForm").fadeOut(200);
				chating = false;
			});

			socket.on('echo', function(data) {
				alert("Echo: " + data.text);
			});

			socket.on('auth_request', function(data) {
				if (!data.admin) {
					$("#usersCount_tr").hide();
					$("#enterInChatBtn").val(" Войти! ");
				} else {
					$("#enterInChatBtn").val(" Создать! ");
				}
				$("#nick").val(getCookie("last_nick"));
				$("#loginForm").fadeIn(200);
			});

			socket.on('login_error', function(data) {
				alert('Ошибка входа. \nПричина: ' + data.text);
			});

			socket.on('error', function(data) {
				alert("Сервер прислал ошибку: " + data.text);
			});

			socket.on('room_is_full', function(data) {
				alert("Извини, но здесь уже достаточно человек, а ты будешь лишним...");
			});

			socket.on('user_exists', function(data) {
				alert('Извини, но такой ник уже используется там!');
			});

			socket.on('start_chat', function(data) {
				chating = true;
				$("#loginForm").fadeOut(200);
				$("#chatForm").fadeIn(200);
				$("#chatList").empty();
				$("#userList").empty();
				//
				cmd('get_user_list', {"roomID": roomID});
				//
				setOnline(true);
			});

			socket.on('end_chat', function(data) {
				$("#loginForm").fadeIn(200);
				$("#chatForm").fadeOut(200);
				chating = false;
				//data.reason
				setOnline(false);
			});

			socket.on('set_invite_link', function(data) {
				linkSpan = $("#inviteLink");
				linkSpan.html("<a href='"+data.link+"' target='_blank' title='Поделись с другими этой ссылкой, что бы пригласить в чат'>"+data.link+"</a>");
				$("#inviteBox").fadeIn(100);
			});

			socket.on('set_user_list', function(data) {
				userList = data.userList;
				if (userList) {
					for(var index in userList) {
						user = userList[index];
						if (user.nick == "")
							continue;
						addUserToList(user);
					}
				}
			});

			socket.on('join', function(data) { //кто-то зашёл в комнату.
				addUserToList(data);
			});

			socket.on('part', function(data) { //кто-то покинул комнату.
				removeUserFromList(data.nick);
			});

			socket.on('message', function(data) {
				text = replaceSmileys(data.text)
				addChatMessage(data.from, text);
			});

			socket.on('typing_notify', function(data) {
				//console.log("typing_notify. User: " + data.nick + '; Typing: ' + data.typing);
				setUserTyping(data.nick, data.typing);
			});

			/**/

			/* всякие клиентские примочечки */

			$("#loginForm").on("submit", function(e) {
				e.preventDefault();

				var nick = $("#nick").val().trim();
				var usersCount = $("#usersCount").val();
				//
				if (!nick.length) {
					alert("Ник не может быть пустым, господин Никто!");
					return false;
				}

				if (!isValidUsersCount(usersCount)) {
					alert("Количество людей должно быть от 2 до " + max_users_count);
					return false;
				}

				setCookie("last_nick", nick);
				mynick = nick;

				cmd("login", {"nick": nick, "usersCount": usersCount, "roomID": roomID});
			});

			$("#chatForm").on("submit", function(e) {
				msg = $("#message").val().trim();				
				if ((msg.length) && (msg[0] == "/" || msg[0] == "\\")) {
					execCMD(msg);
					$("#message").val("");
					return false;
				}

				if (!chating) {
					alert("Нужно сначала войти в чат, а потом уже общеньки общать.");
					return false;
				}

				$("#message").val("");

				if (msg.length) {
					cmd("message", {"text": msg});
				}

				return false;
			});

			$("#message").keypress(function(e) {
				if ($("#message").val().length) {
					sendTypingNotify(true);
				}
			
				if(e.which == 13) {
					e.preventDefault();
					sendTypingNotify(false); //отправили, значит уже не печатаем пока что.
					$("#chatForm").trigger('submit');
				}
			});

			/* typing notification */

			var idleTimer = null;

			function stopTimeout() {
				clearTimeout(idleTimer);
				idleTimer = null;
			}

			function sendTypingNotify(typing) { //typing: boolean;
				if (!typing) {
					cmd('typing_notify', {"typing": false}); //послать, что уже всё...
					stopTimeout();
					return;
				}

				if (!idleTimer) {
					cmd('typing_notify', {"typing": true}); 
				}

				stopTimeout(); //нужно перезапустить таймер.
				idleTimer = setTimeout(function() {
					sendTypingNotify(false);
					stopTimeout();
				}, 4000); //если 4 секунды чел не пишет ничего, то он типа уже не пишет. 
			}

			$("#message").on('focus', function() {
				if ($("#message").val().length) {
					sendTypingNotify(true);
				}	
			});

			$("#message").on('blur', function() {
				sendTypingNotify(false);
			});

			/**/

			/* user list*/

			function addUserToList(user) {
				udiv = $("<div class='user'></div>");
				udiv.attr("nick", user.nick);
				udiv.text(user.nick);
				if (user.nick == mynick) {
					udiv.addClass("itsMe");
				} else {
					if (user.isAdmin) {
						udiv.addClass("itsAdmin");
					}
				}
				udiv.appendTo("#userList");
			}

			function removeUserFromList(nick) {
				nick = nick.toLowerCase();
				udivs = $(".user");
				udivs.each(function(index) {
  					udiv = $(this);
  					if (udiv.attr("nick").toLowerCase() == nick) {
  						udiv.remove();
  					}
				});
			}

			function setUserTyping(nick, typing) {
				uDivs = $(".user");
				for(i in uDivs) {
					udiv = $(uDivs[i]);
					if (nick == udiv.attr("nick")) {
						if (typing) {
							udiv.addClass("user_typing");
						} else {
							udiv.removeClass("user_typing");
						}
						return;
					}
				}
			}

			/**/

			/* вспомогательные функции для UI и не только */

			function goToHomePage(e) {
				if (e) {
					e.preventDefault();
				}
				if (chating) {
					if (!confirm('Вы в чате. Если перейдёте на главную, то выйдете из чата. Вы согласны?')) 
						return false;
				}
				document.location.href = "/";
				return false;
			}

			function setTitle(title) {
				document.title = title;
			}

			function setOnline(online) {
				title = "Room #" + roomID + ' - ' + mynick;
				if (online) {
					title += " - online";
				} else {
					title += " - offline";
				}
				setTitle(title);
			}

			function getEl(element_id) {
				return document.getElementById(element_id);
			}

			function isValidUsersCount(count) {
				return ((count >=2) && (count <= max_users_count));
			}

			function getCurrentTime() {
				function addZeroAfter(num) {
					if (num < 10) {
						return '0' + num;
					} else {
						return num;
					}
				}
				var t = new Date();
				return addZeroAfter(t.getHours()) + ':' + addZeroAfter(t.getMinutes()) + ':' + addZeroAfter(t.getSeconds());
			}

			function addChatMessage(nick, message, color) {
				chatList = $("#chatList");
				if (nick == mynick) {
					c = "itsMe";
				} else {
					c = "noMe";
				}
				/*$("<p><div class='chatMessage'><div class='nickInChat'><span class='"+c+"'>" + nick + "</span> ["+getCurrentTime()+"]</div><div class='messageText'>"+message+"</div></div></p>").appendTo(chatList);
				*/
				$("<p><div class='chatMessage'>["+getCurrentTime()+"]<br /><span nick='"+nick+"' class='nickInChat "+c+"'>" + nick + "</span>: "+message+"</div></p>").appendTo(chatList);
				//прокрутить вниз до конца. //TODO: добавить чек-бокс, что бы выбирать, прокручивать ли до конца автоматом или нет.
				chatDiv = getEl("chatList");
				chatList.animate({scrollTop: chatDiv.scrollHeight}, 200);
			}

			/* cookies */

			function getCookie(name) {
  				var matches = document.cookie.match(new RegExp(
    				"(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"
  				));
  				return matches ? decodeURIComponent(matches[1]) : null;
			}

			function setCookie(name, value, options) {
  				options = options || {};
  				var expires = options.expires;
  				if (typeof expires == "number" && expires) {
    				var d = new Date();
    				d.setTime(d.getTime() + expires*1000);
    				expires = options.expires = d;
  				}
  				if (expires && expires.toUTCString) { 
  					options.expires = expires.toUTCString();
  				}
  				value = encodeURIComponent(value);
  				var updatedCookie = name + "=" + value;
  				for(var propName in options) {
    				updatedCookie += "; " + propName;
    				var propValue = options[propName];    
    				if (propValue !== true) { 
      					updatedCookie += "=" + propValue;
     				}
  				}
  				document.cookie = updatedCookie;
			}

			/* обработка пользовательских комманд. */

			function execCMD(str) { //когда текст в чате начинается с / или \ символа
				str = str.substring(1);
				var params = [];
				var paramss = str.split(" ");
				for(i in paramss) { //очистка от пустых параметров из-за нескольких пробелов.
					p = paramss[i].trim();
					if (p != "") {
						params.push(p);
					}
				}
				var act = params[0];

				//
				switch (act) {
					case "clear": clearChatList(); break;
					case "alert": alert(params[1]); break;
					case "part": part(); break;
				}
			}

			function part() { //покинуть чат.
				cmd('part');
			}

			function clearChatList() {
				if (confirm("Очистить все сообщения в чате?")) {
					$("#chatList").empty();
				}
			}

			/**/

			function setChatRect() {
				c = $("#chatList");
				c.css("width", $(window).width() - $("#userList").width());
				c.css("height", $(window).height() - $("#footer").height() - 30);

				setTimeout(setChatRect, 550);
			}

			function init() {
				setChatRect();
				//
				$("#homeLink").on('click', goToHomePage);
				/**/
				mynick = getCookie("last_nick");
				//
				setOnline(false);
			}

			init();
		});